package io.fabric8.kubernetes.api.model.discovery.v1;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import java.util.function.Predicate;
import io.fabric8.kubernetes.api.model.ObjectMetaFluent;
import java.lang.Deprecated;
import java.util.Iterator;
import java.util.List;
import java.lang.Boolean;
import io.fabric8.kubernetes.api.model.ObjectMeta;
import io.fabric8.kubernetes.api.builder.Fluent;
import io.fabric8.kubernetes.api.model.ObjectMetaBuilder;
import java.lang.Integer;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;

 /**
  * Generated
  */
public interface EndpointSliceFluent<A extends io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public java.lang.String getAddressType();
  public A withAddressType(java.lang.String addressType);
  public java.lang.Boolean hasAddressType();
  
  /**
   * Method is deprecated. use withAddressType instead.
   */
  @java.lang.Deprecated
  public A withNewAddressType(java.lang.String arg0);
  public java.lang.String getApiVersion();
  public A withApiVersion(java.lang.String apiVersion);
  public java.lang.Boolean hasApiVersion();
  
  /**
   * Method is deprecated. use withApiVersion instead.
   */
  @java.lang.Deprecated
  public A withNewApiVersion(java.lang.String arg0);
  public A addToEndpoints(java.lang.Integer index,io.fabric8.kubernetes.api.model.discovery.v1.Endpoint item);
  public A setToEndpoints(java.lang.Integer index,io.fabric8.kubernetes.api.model.discovery.v1.Endpoint item);
  public A addToEndpoints(io.fabric8.kubernetes.api.model.discovery.v1.Endpoint... items);
  public A addAllToEndpoints(java.util.Collection<io.fabric8.kubernetes.api.model.discovery.v1.Endpoint> items);
  public A removeFromEndpoints(io.fabric8.kubernetes.api.model.discovery.v1.Endpoint... items);
  public A removeAllFromEndpoints(java.util.Collection<io.fabric8.kubernetes.api.model.discovery.v1.Endpoint> items);
  public A removeMatchingFromEndpoints(java.util.function.Predicate<io.fabric8.kubernetes.api.model.discovery.v1.EndpointBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildEndpoints instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public java.util.List<io.fabric8.kubernetes.api.model.discovery.v1.Endpoint> getEndpoints();
  public java.util.List<io.fabric8.kubernetes.api.model.discovery.v1.Endpoint> buildEndpoints();
  public io.fabric8.kubernetes.api.model.discovery.v1.Endpoint buildEndpoint(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.discovery.v1.Endpoint buildFirstEndpoint();
  public io.fabric8.kubernetes.api.model.discovery.v1.Endpoint buildLastEndpoint();
  public io.fabric8.kubernetes.api.model.discovery.v1.Endpoint buildMatchingEndpoint(java.util.function.Predicate<io.fabric8.kubernetes.api.model.discovery.v1.EndpointBuilder> predicate);
  public java.lang.Boolean hasMatchingEndpoint(java.util.function.Predicate<io.fabric8.kubernetes.api.model.discovery.v1.EndpointBuilder> predicate);
  public A withEndpoints(java.util.List<io.fabric8.kubernetes.api.model.discovery.v1.Endpoint> endpoints);
  public A withEndpoints(io.fabric8.kubernetes.api.model.discovery.v1.Endpoint... endpoints);
  public java.lang.Boolean hasEndpoints();
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.EndpointsNested<A> addNewEndpoint();
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.EndpointsNested<A> addNewEndpointLike(io.fabric8.kubernetes.api.model.discovery.v1.Endpoint item);
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.EndpointsNested<A> setNewEndpointLike(java.lang.Integer index,io.fabric8.kubernetes.api.model.discovery.v1.Endpoint item);
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.EndpointsNested<A> editEndpoint(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.EndpointsNested<A> editFirstEndpoint();
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.EndpointsNested<A> editLastEndpoint();
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.EndpointsNested<A> editMatchingEndpoint(java.util.function.Predicate<io.fabric8.kubernetes.api.model.discovery.v1.EndpointBuilder> predicate);
  public java.lang.String getKind();
  public A withKind(java.lang.String kind);
  public java.lang.Boolean hasKind();
  
  /**
   * Method is deprecated. use withKind instead.
   */
  @java.lang.Deprecated
  public A withNewKind(java.lang.String arg0);
  
  /**
   * This method has been deprecated, please use method buildMetadata instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.ObjectMeta getMetadata();
  public io.fabric8.kubernetes.api.model.ObjectMeta buildMetadata();
  public A withMetadata(io.fabric8.kubernetes.api.model.ObjectMeta metadata);
  public java.lang.Boolean hasMetadata();
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.MetadataNested<A> withNewMetadata();
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.MetadataNested<A> withNewMetadataLike(io.fabric8.kubernetes.api.model.ObjectMeta item);
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.MetadataNested<A> editMetadata();
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.MetadataNested<A> editOrNewMetadata();
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.MetadataNested<A> editOrNewMetadataLike(io.fabric8.kubernetes.api.model.ObjectMeta item);
  public A addToPorts(java.lang.Integer index,io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort item);
  public A setToPorts(java.lang.Integer index,io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort item);
  public A addToPorts(io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort... items);
  public A addAllToPorts(java.util.Collection<io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort> items);
  public A removeFromPorts(io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort... items);
  public A removeAllFromPorts(java.util.Collection<io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort> items);
  public A removeMatchingFromPorts(java.util.function.Predicate<io.fabric8.kubernetes.api.model.discovery.v1.EndpointPortBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildPorts instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public java.util.List<io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort> getPorts();
  public java.util.List<io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort> buildPorts();
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort buildPort(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort buildFirstPort();
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort buildLastPort();
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort buildMatchingPort(java.util.function.Predicate<io.fabric8.kubernetes.api.model.discovery.v1.EndpointPortBuilder> predicate);
  public java.lang.Boolean hasMatchingPort(java.util.function.Predicate<io.fabric8.kubernetes.api.model.discovery.v1.EndpointPortBuilder> predicate);
  public A withPorts(java.util.List<io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort> ports);
  public A withPorts(io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort... ports);
  public java.lang.Boolean hasPorts();
  public A addNewPort(java.lang.String appProtocol,java.lang.String name,java.lang.Integer port,java.lang.String protocol);
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.PortsNested<A> addNewPort();
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.PortsNested<A> addNewPortLike(io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort item);
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.PortsNested<A> setNewPortLike(java.lang.Integer index,io.fabric8.kubernetes.api.model.discovery.v1.EndpointPort item);
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.PortsNested<A> editPort(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.PortsNested<A> editFirstPort();
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.PortsNested<A> editLastPort();
  public io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.PortsNested<A> editMatchingPort(java.util.function.Predicate<io.fabric8.kubernetes.api.model.discovery.v1.EndpointPortBuilder> predicate);
  public interface EndpointsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.discovery.v1.EndpointFluent<io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.EndpointsNested<N>>{
    public N and();
    public N endEndpoint();
    
  }
  public interface MetadataNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.ObjectMetaFluent<io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.MetadataNested<N>>{
    public N and();
    public N endMetadata();
    
  }
  public interface PortsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.discovery.v1.EndpointPortFluent<io.fabric8.kubernetes.api.model.discovery.v1.EndpointSliceFluent.PortsNested<N>>{
    public N and();
    public N endPort();
    
  }
  
}