package io.fabric8.kubernetes.api.model.discovery.v1beta1;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import java.util.LinkedHashMap;
import java.util.function.Predicate;
import io.fabric8.kubernetes.api.model.ObjectReference;
import java.lang.Deprecated;
import java.util.List;
import java.lang.Boolean;
import io.fabric8.kubernetes.api.builder.Fluent;
import java.lang.Integer;
import io.fabric8.kubernetes.api.model.ObjectReferenceFluent;
import io.fabric8.kubernetes.api.model.ObjectReferenceBuilder;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;

 /**
  * Generated
  */
public interface EndpointFluent<A extends io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public A addToAddresses(java.lang.Integer index,java.lang.String item);
  public A setToAddresses(java.lang.Integer index,java.lang.String item);
  public A addToAddresses(java.lang.String... items);
  public A addAllToAddresses(java.util.Collection<java.lang.String> items);
  public A removeFromAddresses(java.lang.String... items);
  public A removeAllFromAddresses(java.util.Collection<java.lang.String> items);
  public java.util.List<java.lang.String> getAddresses();
  public java.lang.String getAddress(java.lang.Integer index);
  public java.lang.String getFirstAddress();
  public java.lang.String getLastAddress();
  public java.lang.String getMatchingAddress(java.util.function.Predicate<java.lang.String> predicate);
  public java.lang.Boolean hasMatchingAddress(java.util.function.Predicate<java.lang.String> predicate);
  public A withAddresses(java.util.List<java.lang.String> addresses);
  public A withAddresses(java.lang.String... addresses);
  public java.lang.Boolean hasAddresses();
  public A addNewAddress(java.lang.String arg0);
  
  /**
   * This method has been deprecated, please use method buildConditions instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointConditions getConditions();
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointConditions buildConditions();
  public A withConditions(io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointConditions conditions);
  public java.lang.Boolean hasConditions();
  public A withNewConditions(java.lang.Boolean ready,java.lang.Boolean serving,java.lang.Boolean terminating);
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.ConditionsNested<A> withNewConditions();
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.ConditionsNested<A> withNewConditionsLike(io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointConditions item);
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.ConditionsNested<A> editConditions();
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.ConditionsNested<A> editOrNewConditions();
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.ConditionsNested<A> editOrNewConditionsLike(io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointConditions item);
  
  /**
   * This method has been deprecated, please use method buildHints instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointHints getHints();
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointHints buildHints();
  public A withHints(io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointHints hints);
  public java.lang.Boolean hasHints();
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.HintsNested<A> withNewHints();
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.HintsNested<A> withNewHintsLike(io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointHints item);
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.HintsNested<A> editHints();
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.HintsNested<A> editOrNewHints();
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.HintsNested<A> editOrNewHintsLike(io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointHints item);
  public java.lang.String getHostname();
  public A withHostname(java.lang.String hostname);
  public java.lang.Boolean hasHostname();
  
  /**
   * Method is deprecated. use withHostname instead.
   */
  @java.lang.Deprecated
  public A withNewHostname(java.lang.String arg0);
  public java.lang.String getNodeName();
  public A withNodeName(java.lang.String nodeName);
  public java.lang.Boolean hasNodeName();
  
  /**
   * Method is deprecated. use withNodeName instead.
   */
  @java.lang.Deprecated
  public A withNewNodeName(java.lang.String arg0);
  
  /**
   * This method has been deprecated, please use method buildTargetRef instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.ObjectReference getTargetRef();
  public io.fabric8.kubernetes.api.model.ObjectReference buildTargetRef();
  public A withTargetRef(io.fabric8.kubernetes.api.model.ObjectReference targetRef);
  public java.lang.Boolean hasTargetRef();
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.TargetRefNested<A> withNewTargetRef();
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.TargetRefNested<A> withNewTargetRefLike(io.fabric8.kubernetes.api.model.ObjectReference item);
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.TargetRefNested<A> editTargetRef();
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.TargetRefNested<A> editOrNewTargetRef();
  public io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.TargetRefNested<A> editOrNewTargetRefLike(io.fabric8.kubernetes.api.model.ObjectReference item);
  public A addToTopology(java.lang.String key,java.lang.String value);
  public A addToTopology(java.util.Map<java.lang.String,java.lang.String> map);
  public A removeFromTopology(java.lang.String key);
  public A removeFromTopology(java.util.Map<java.lang.String,java.lang.String> map);
  public java.util.Map<java.lang.String,java.lang.String> getTopology();
  public <K,V>A withTopology(java.util.Map<java.lang.String,java.lang.String> topology);
  public java.lang.Boolean hasTopology();
  public interface ConditionsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointConditionsFluent<io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.ConditionsNested<N>>{
    public N and();
    public N endConditions();
    
  }
  public interface HintsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointHintsFluent<io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.HintsNested<N>>{
    public N and();
    public N endHints();
    
  }
  public interface TargetRefNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.ObjectReferenceFluent<io.fabric8.kubernetes.api.model.discovery.v1beta1.EndpointFluent.TargetRefNested<N>>{
    public N and();
    public N endTargetRef();
    
  }
  
}